--*------------------------------------------------------------------*
--*  drawbox.e  text box and message box routines                    *
--*------------------------------------------------------------------*

without warning
  include graphics.e
  include image.e

 global procedure DrawBox(sequence parm)
   integer start_row,  start_col,  end_row, end_col,
           fore_color, back_color, shadow,  boxlen

    start_row = parm[1]
    start_col = parm[2]
      end_row = parm[3]
      end_col = parm[4]

    if length(parm) > 4 then
      fore_color = parm[5]
    else
      fore_color = CYAN
    end if

    if length(parm) > 5 then
      back_color = parm[6]
    else
      back_color = BLUE
    end if

    if length(parm) > 6 then
      shadow = parm[7]
    else
      shadow = 1
    end if

    boxlen    = end_col - start_col + 1

    text_color(fore_color)  bk_color(back_color)
    for i = start_row to end_row do
      position(i, start_col) puts(1, repeat('', boxlen))
    end for

    text_color(15)  bk_color(fore_color)
    position(start_row, start_col) puts(1, "" & repeat('', boxlen - 2) & "")
    for i = start_row + 1 to end_row - 1 do
      position(i, start_col) puts(1, "")
      position(i, end_col)   puts(1, "")
    end for
    position(end_row, start_col)   puts(1, "" & repeat('', boxlen - 2) & "")

    if shadow then
      text_color(0)                                  -- draw shadow
      for i = start_row + 1 to end_row + 1 do
        position(i, start_col - 1) puts(1, "")
      end for
      position(end_row + 1, start_col - 1) puts(1, repeat('', boxlen - 1))
    end if

  end procedure

global procedure DrawBorder(sequence borderinfo)
  integer startrow,  startcol,  endrow,endcol,
          forecolor, backcolor, bordercolor
  integer boxlen

  startrow    = borderinfo[1]
  startcol    = borderinfo[2]
  endrow      = borderinfo[3]
  endcol      = borderinfo[4]
  forecolor   = borderinfo[5]
  backcolor   = borderinfo[6]
  bordercolor = borderinfo[7]

  boxlen = endcol - startcol + 1
  text_color(forecolor)  bk_color(backcolor)
  clear_screen()

  text_color(bordercolor)
  position (startrow, startcol)  puts (1, repeat('', boxlen))
  if endrow = 25 and endcol = 80 then
    position (24, startcol)      puts (1, repeat('', boxlen))  --put bar on line 24 and
    scroll(-1, 24, 25)                                          --scroll down 1 line
  else
    position (endrow, startcol)  puts (1, repeat('', boxlen))
  end if

  for i = startrow to endrow do               -- side  borders
    position (i, startcol)    puts (1, "")   -- left  border
    if i = 25 then
      if endcol != 80 then
        position (i, endcol)  puts (1, "")   -- right border
      end if
    else
      position (i, endcol)    puts (1, "")   -- right border
    end if
  end for

end procedure

global procedure RandomDots(integer numdots)
  for i = 1 to numdots do
    position(rand(24), rand(80)) puts(1, 250)
  end for
end procedure

global procedure CenterText(sequence parm)
  sequence text
  integer startrow, startcol, endcol, midpoint, stext

  startrow = parm[1]
  startcol = parm[2]
  endcol   = parm[3]
  text     = parm[4]

  midpoint = floor((startcol + endcol) / 2)
  stext    = floor(midpoint - length(text) / 2)
  position(startrow, stext) puts(1, text)

end procedure

global procedure MsgBox(sequence parm)
  sequence text, SaveBoxArea
  integer startrow, startcol, endrow, endcol,
          anykey, longest

  if atom(parm[1]) then
    text = {parm}                 -- make string a one-element sequence
  else
    text = parm
  end if

  startrow = 12 - floor(length(text) / 2)
  endrow   = startrow + length(text) - 1

  longest = 0
  for i = 1 to length(text) do          -- find longest line
    if length(text[i]) > longest then
      longest = length(text[i])
    end if
  end for

  if longest > 80 then
    puts(1, "function MsgBox(Drawbox.e): longest line > 80 characters\n")
    abort(1)
  end if

  startcol = 40 - floor(longest / 2)       -- get left side of box to draw
  endcol = startcol + longest              -- get right side of box
  SaveBoxArea = save_text_image({startrow - 1, startcol - 2}, {endrow + 3, endcol + 2})
  DrawBox({startrow - 1, startcol - 1, endrow + 2, endcol + 1})
  text_color(BRIGHT_WHITE)  bk_color(CYAN)

  for i = 1 to length(text) do                -- display message
    position(startrow + i - 1, startcol) puts(1, text[i])
  end for

  position(startrow + length(text), 39) puts(1, "OK")

  while 1 do
    anykey = wait_key()
    if anykey = ESC or anykey = EnterKey then
       exit
    end if
  end while

  display_text_image({startrow - 1, startcol - 2}, SaveBoxArea)
  text_color(WHITE)  bk_color(BLUE)

end procedure

global procedure TextBox(sequence parm)
  sequence text
  integer startrow, startcol, endrow, endcol, longest

  if atom(parm[1]) then
    text = {parm}                 -- make string a one-element sequence
  else
    text = parm
  end if

  startrow = 12 - floor(length(text) / 2)
  endrow   = startrow + length(text) - 1

  longest = 0
  for i = 1 to length(text) do          -- find longest line
    if length(text[i]) > longest then
      longest = length(text[i])
    end if
  end for

  if longest > 80 then
    puts(1, "function TextBox(Drawbox.e): longest line > 80 characters\n")
    abort(1)
  end if

  startcol = 40 - floor(longest / 2)       -- get left side of box to draw
  endcol   = startcol + longest            -- get right side of box
  DrawBox({startrow - 1, startcol - 1, endrow + 2, endcol + 1})
  text_color(BRIGHT_WHITE)  bk_color(CYAN)

  for i = 1 to length(text) do                -- display message
    position(startrow + i - 1, startcol) puts(1, text[i])
  end for

  text_color(WHITE)  bk_color(BLUE)

end procedure

global procedure MsgBox_at(sequence parm)
  sequence text, SaveBoxArea
  integer startrow, startcol, endrow, endcol, midpoint,
          anykey, longest

  startrow = parm[1]
  startcol = parm[2]
  text     = parm[3]
  if atom(text[1]) then      -- make text a one-length sequence
    text = {text}
  end if
  endrow   = startrow + length(text) - 1

  longest = 0                -- find longest line
  for i = 1 to length(text) do
    if length(text[i]) > longest then
      longest = length(text[i])
    end if
  end for

  endcol   = startcol + longest
  if endcol > 78 then
    puts(1, "function MsgBox_at(Drawbox.e) : lines too long to fit on screen")
    abort(1)
  end if

  midpoint    = floor((startcol + endcol) / 2)
  SaveBoxArea = save_text_image({startrow - 1, startcol - 2}, {endrow + 3, endcol + 2})
  DrawBox({startrow - 1, startcol - 1, endrow + 2, endcol + 1})
  text_color(BRIGHT_WHITE)  bk_color(CYAN)

  for i = 1 to length(text) do                   -- display messages
    position(startrow + i - 1, startcol) puts(1, text[i])
  end for
  position(startrow + length(text), midpoint - 1) puts(1, "OK")

  while 1 do
    anykey = wait_key()
    if anykey = ESC or anykey = EnterKey then
       exit
    end if
  end while
  display_text_image({startrow - 1, startcol - 2}, SaveBoxArea)
  text_color(WHITE)  bk_color(BLUE)

end procedure

global procedure TextBox_at(sequence parm)
  sequence text
  integer startrow, startcol, endrow, endcol, midpoint, longest

  startrow = parm[1]
  startcol = parm[2]
  text     = parm[3]
  if atom(text[1]) then      -- make text a one-length sequence
    text = {text}
  end if
  endrow   = startrow + length(text) - 1

  longest = 0                -- find longest line
  for i = 1 to length(text) do
    if length(text[i]) > longest then
      longest = length(text[i])
    end if
  end for

  endcol   = startcol + longest
  if endcol > 78 then
    puts(1, "function TextBox_at(Drawbox.e) : lines too long to fit on screen")
    abort(1)
  end if

  midpoint = floor((startcol + endcol) / 2)
  DrawBox({startrow - 1, startcol - 1, endrow + 2, endcol + 1})
  text_color(BRIGHT_WHITE)  bk_color(CYAN)

  for i = 1 to length(text) do                   -- display messages
    position(startrow + i - 1, startcol) puts(1, text[i])
  end for
  text_color(WHITE)  bk_color(BLUE)

end procedure

global function InputBox(sequence text)
  sequence SaveBoxArea, response

  SaveBoxArea = save_text_image({9, 11}, {16, 72})
  DrawBox({10, 20, 13, 70})
  text_color(BRIGHT_WHITE)  bk_color(CYAN)
  position(11, 22) puts(1, text)
  position(12, 22)
  response = gets(0)
  response = response[1..length(response) - 1]
  display_text_image({9, 11}, SaveBoxArea)

  return response

end function

global procedure PrintStatusLine(sequence Statusline, sequence Highlights)
  integer s1

  text_color(BLACK) bk_color(CYAN)
  position(24, 1) puts(1, repeat(' ', 80))
  position(24, 1) puts(1, Statusline)
  text_color(BRIGHT_WHITE)

  for i = 1 to length(Highlights) do
    s1 = match(Highlights[i], Statusline)
    if s1 > 0 then
      position(24, s1) puts(1, Highlights[i])
    end if
  end for

  scroll(-1, 24, 25)
  text_color(WHITE) bk_color(BLUE)
  position(24, 1) puts(1, repeat(' ', 80))

end procedure

